#
# List all "postings" of the Business Informer datamodel in the
# database "tutorial" and allow edit operations. Furthermore, perform
# mode detailed timings and report the results.
#

set t0 [ns_time get]
set t(setup)   [ns_time diff $t0 [ns_conn start]]

::nx::mongo::db connect -db "tutorial"
set t(connect) [ns_time diff [ns_time get] $t0]

set html ""
set timings "Timings: "

namespace eval ::bi {

  set t1 [ns_time get]

  if {[Posting count] > 0} {

    set ::t(count) [ns_time diff [ns_time get] $t1]

    set t1 [ns_time get]
    set result [nx::Object new {set :postings [Posting find all -orderby ts]}]
    set ::t(findall) [ns_time diff [ns_time get] $t1]
    
    $result template set {
      Postings: <ul><FOREACH var='p' in=':postings' type='list'><li>@p;obj;edit@<p></li>
      </FOREACH></ul>
    }

    set t1 [ns_time get]
    set ::html [$result template eval]
    set ::t(template) [ns_time diff [ns_time get] $t1]
    set ::t(total)    [ns_time diff [ns_time get] $::t0]
    
    foreach cp {setup connect count findall template total} {
      append ::timings "$cp [format %5.3f [expr {[ns_time format $::t($cp)]*1000}]]ms "
    }
    $result destroy
  }
}

ns_return 200 text/html "
<hr>
[bi::navigation-bar]
<hr>
$html
<hr>
<a href='new.tcl'>new posting</a> &sdot; $timings

<hr>
<pre>
[bi::classes]

postings: [bi::Posting show -puts 0]
</pre>
"
